# ux2p-XXX-OracleOffline
# by mail@meo.bogliolo.name (c)
#
# HTML Oracle Offline Plugin
# Reports Oracle configuration details for offline RDBMS
#
# Usage:
# called by ux2html.sh 
#
# Notes:

# History:
#   14 Feb 14 1.0.0       meo     First release derived from Oracle Details plugin

PL_VERSION=1.0.0d
PL_DESCR="Oracle Offine report"

OERRLEN=200
ORA_USERS="oracle grid"
ORA_SID="orcl"
# ORA_SID="XE"

echo '<P><A NAME="oraoff"></A><H2>' $PL_DESCR '</h2>' 
echo 'Plug-in version:' $PL_VERSION
echo '<p>Contents: <a href="#ora_tab">oratab</a>, <a href="#ora_log">Logs</a>,  <a href="#ora_asm">ASM</a>'
echo '<p><p><a id="ora_tab"></a>oratab:<pre>'
grep -v ^$ /etc/oratab | grep -v ^# 2>/dev/null
echo '</pre><p>'

OHOME='cd $ORACLE_HOME'
export OHOME
echo '<a id="ora_log"></a>Oracle Logs:<ul>'

for INST in $ORA_USERS
do
 USR=$INST
 SID=$ORA_SID

 echo "<li>" User: $USR  "<!--"
 su - $USR << EOF
echo '--><ul>'
eval $OHOME
find . -name 'alert*.log' -exec echo "<li><b>" {} "</b><pre>" \; -exec tail -$OERRLEN {} \; -exec echo "</pre>" \; 2>/dev/null
# OFA
find ../../admin -name 'alert*.log' -exec echo "<li><b>" {} "</b><pre>" \; -exec tail -$OERRLEN {} \; -exec echo "</pre>" \; 2>/dev/null
# XE
find ../../../admin -name 'alert*.log' -exec echo "<li><b>" {} "</b><pre>" \; -exec tail -$OERRLEN {} \; -exec echo "</pre>" \; 2>/dev/null
# 11g
find ../../diag -name 'alert*.log' -exec echo "<li><b>" {} "</b><pre>" \; -exec tail -$OERRLEN {} \; -exec echo "</pre>" \; 2>/dev/null
find ../../../diag -name 'alert*.log' -exec echo "<li><b>" {} "</b><pre>" \; -exec tail -$OERRLEN {} \; -exec echo "</pre>" \; 2>/dev/null
find ../../../grid/diag -name 'alert*.log' -exec echo "<li><b>" {} "</b><pre>" \; -exec tail -$OERRLEN {} \; -exec echo "</pre>" \; 2>/dev/null
find . -name 'listener*.log' -exec echo "<li><b>" {} "</b><pre>" \; -exec tail -$OERRLEN {} \; -exec echo "</pre>" \; 2>/dev/null
EOF
echo '--></ul>'
done

echo '</ul><p></ul><a id="ora_asm"></a>'
oracleasm -V > /dev/null 2>/dev/null
TEST=$?
if [ $TEST -eq 0 ]
then
  echo '<h2>Oracle ASMlib</h2>'
  echo "<pre>"
  oracleasm -V
  oracleasm status
  echo; echo "Disk list:"
  oracleasm listdisks
  echo; echo "Disk devices:"
  oracleasm listdisks | xargs oracleasm querydisk -p
  echo "</pre>"
else
  echo '<h3>Oracle ASMlib not found</h3>'
fi

echo '<p>'
