# ux2p-XXX-OracleLsnrLogs
# by mail@meo.bogliolo.name (c)
#
# HTML Oracle Plugin
# Reports Oracle Listener logs
#
# Usage:
# called by ux2html.sh 
#
# Notes:
# 	The only requirement is that the user executing oracle (the pmon process) has
#	the right setup on login to connect to Oracle RDBMS

# History:
#   1 Apr 16 1.0.0       meo     First release based on Oracle plugin
#   3 Sep 22 1.0.1       meo     No more egrep (deprecated since 2007 and with a warning in grep 3.8)

PL_VERSION=1.0.1
PL_DESCR="Oracle Listener Logs"

INST_DIR=/usr/local/amm
OERRLEN=400

SYSTYPE=`uname -s`
EGREP=grep
if [ $SYSTYPE = HPUX -o $SYSTYPE = HP-UX ]
then
   export UNIX95=
   EGREP="grep -E"
fi
PSCMD='ps -e -o user=VeryLongUserNames -o args'
if [ $SYSTYPE = Cygwin ]
then
   PSCMD='ps -lW '
fi
OHOME='cd $ORACLE_HOME'
export OHOME

USR1=none
FIRSTTIME=yes
echo '<P><A NAME="oralsnr"></A><H2>' $PL_DESCR '</h2>' 
echo 'Plug-in version:' $PL_VERSION
echo '<p>Contents: <a href="#ora_lis">Listeners</a>'

echo '</pre><p><a id="ora_ins"></a>Oracle Instances (SID):<ul><li>'

chmod o+xr $INST_DIR

for INST in `$PSCMD | grep pmon | grep -v grep | grep -v exadata_mon | grep -v awk | grep -v FNDLIBR | \
    awk ' { printf("%s:%s\n", $1, substr($2,index($2,"pmon")+5) ) }' | sort `
do
 USR=`echo $INST | awk -F: ' { print $1 }' `
 SID=`echo $INST | awk -F: ' { print $2 }' `
 ORH=`grep ^$SID: /etc/oratab | awk -F: ' { print $2 }' `

 echo "<a href="`uname -n`.$SID.htm">" $SID "</a> ; " "<!--"
done

FIRSTTIME=yes

USR1=none
echo '</ul><p><a id="ora_log"></a>Listener Logs:<ul>'

for INST in `$PSCMD | grep pmon | grep -v grep | grep -v exadata_mon | grep -v awk | grep -v FNDLIBR | \
    awk ' { printf("%s:%s\n", $1, substr($2,index($2,"pmon")+5) ) }' | sort `
do
 USR=`echo $INST | awk -F: ' { print $1 }' `
 SID=`echo $INST | awk -F: ' { print $2 }' `

 if [ $USR != $USR1 ]
  then
        echo "<li>" User: $USR  "<!--"
    su - $USR << EOF
echo '-->'
eval $OHOME
find . -name 'listener*.log' -exec echo "<li><b>" {} "</b><pre>" \; -exec tail -$OERRLEN {} \; -exec echo "</pre>" \; 2>/dev/null
exec echo "</pre>" \; 2>/dev/null

EOF
echo '</ul>'
 fi
USR1=$USR
done


echo '<p>'

