# ux2p-XXX-OracleNoRoot
# by mail@meo.bogliolo.name (c)
#
# HTML Oracle Plugin
# Reports Oracle configuration details launched as Oracle unix user (no root access)
#
# Usage:
# called by ux2html.sh 
#
# Notes:

# History:
#   1 Apr 08 1.0.0       meo     First release derived from OracleDetail.011 plugin
#   1 Apr 09 1.0.1       meo     opatch
#   1 Apr 09 1.0.2       meo     standalone version, better security, bug fixing
#  25 Apr 09 1.0.3       meo     AIX, csh users dirty trick, HP-UX trick
#  31 Jun 09 1.0.4       meo     Listeners' List
#  31 Jun 09 1.0.5       meo     LOGs
#   3 Sep 22 1.0.6       meo     No more egrep (deprecated since 2007 and with a warning in grep 3.8)

PL_VERSION=1.0.6
PL_DESCR="Oracle RDBMS Details NoRoot"

INST_DIR=.
ORA_CMD=ora2html.sql
#ORA_CMD=ora2fast.sql
OPATCH_PARAM='-invPtrLoc $ORACLE_HOME/oraInst.loc'
OPATCH_CMD='$ORACLE_HOME/OPatch/opatch'
SYSTYPE=`uname -s`
EGREP=grep
if [ $SYSTYPE = HPUX -o $SYSTYPE = HP-UX ]
then
   export UNIX95=
   EGREP="grep -E"
fi
PSCMD='ps -e -o user=VeryLongUserNames -o args'
if [ $SYSTYPE = Cygwin ]
then
   PSCMD='ps -lW '
fi

USR1=none
FIRSTTIME=yes
echo '<P><A NAME="oradet"></A><H2>' $PL_DESCR '</h2>' 
echo 'Plug-in version:' $PL_VERSION
echo '<p>Contents: <a href="#ora_ins">Instances</a>, <a href="#ora_lis">Listeners</a>, <a href="#ora_pat">Patches</a>,'
echo ' <a href="#ora_log">Logs</a>'
echo '<p>'
echo '<p><a id="ora_ins"></a>Oracle Instances (SID):<ul><li>'

chmod o+xr $INST_DIR

for INST in `$PSCMD | grep pmon | grep -v grep | \
    awk ' { printf("%s:%s\n", $1, substr($2,10,20) ) }' | sort `
do
 USR=`echo $INST | awk -F: ' { print $1 }' `
 SID=`echo $INST | awk -F: ' { print $2 }' `

 echo "<a href="`uname -n`.$SID.htm">" $SID "</a> ; " "<!"
 touch `uname -n`.$SID.htm
 chmod 777 `uname -n`.$SID.htm
 touch ora2html.htm
 chmod 777 ora2html.htm

 sh <<EOF
cd $INST_DIR
ORACLE_SID=$SID
export ORACLE_SID
# Poor man trick
setenv ORACLE_SID $SID
sqlplus -s '/ as sysdba' < $ORA_CMD > /dev/null
cp ora2html.htm `uname -n`.$SID.htm
touch ora2html.htm
EOF
echo ">"

done
echo '</ul>'
rm ora2html.htm

echo '<p><a id="ora_lis"></a>Oracle Listeners:<ul>'
for INST in `$PSCMD | grep tnslsnr | grep -v grep | \
    awk ' { printf("%s:%s\n", $1, $3 ) }' | sort `
do
 USR=`echo $INST | awk -F: ' { print $1 }' `
 SID=`echo $INST | awk -F: ' { print $2 }' `
 echo "<!"
    sh << EOF
echo "><li>User:" $USR " Listener: " $SID "<pre>"
lsnrctl status $SID | $EGREP "DESCRIPTION|handler" | uniq
echo "</pre>"
EOF
done

FIRSTTIME=yes
echo '</ul><p><a id="ora_pat"></a>Oracle Patches:<ul>'

for INST in `$PSCMD | grep pmon | grep -v grep | \
    awk ' { printf("%s:%s\n", $1, substr($2,10,20) ) }' | sort `
do
 USR=`echo $INST | awk -F: ' { print $1 }' `
 SID=`echo $INST | awk -F: ' { print $2 }' `

 if [ $USR != $USR1 ]
  then
    if [ $FIRSTTIME = yes ]
      then
	FIRSTTIME=no
        echo "<li>" User: $USR  "<!"
      else
        echo "</ul><p><li>" User: $USR  "<!"
    fi
    sh << EOF
echo '><ul><PRE>'
eval $OPATCH_CMD lsinventory $OPATCH_PARAM  | grep -v '^$'
echo '</PRE>'
EOF
 USR1=$USR
 fi

 echo "<li>" SID: "<a href="`uname -n`.$SID.htm">" $SID "</a>"
done

OHOME='cd $ORACLE_HOME'
USR1=none
echo '</ul><p><a id="ora_log"></a>Oracle Logs:<ul>'

for INST in `$PSCMD | grep pmon | grep -v grep | \
    awk ' { printf("%s:%s\n", $1, substr($2,10,20) ) }' | sort `
do
 USR=`echo $INST | awk -F: ' { print $1 }' `
 SID=`echo $INST | awk -F: ' { print $2 }' `

 if [ $USR != $USR1 ]
  then
        echo "<li>" User: $USR  "<!"
    sh << EOF
echo '><ul>'
# eval $OHOME
find . -name 'alert*.log' -exec echo "<li><b>" {} "</b><pre>" \; -exec tail -100 {} \; -exec echo "</pre>" \;
find . -name 'listener*.log' -exec echo "<li><b>" {} "</b><pre>" \; -exec tail -100 {} \; -exec echo "</pre>" \;
EOF
echo '</ul>'
 fi
USR1=$USR
done

echo '<p>'
