# ux2p-XXX-InformixOn
# by mail@meo.bogliolo.name (c)
#
# HTML Informix OnLine Plugin
# Reports Informix OnLine configuration details
#
# Usage:
# called by ux2html.sh 
#
# Notes:
#  Uses SUMMARY, SYSTYPE, PS variables

# History:
#  1 Jan 09 1.0.0       meo     Initial

PL_VERSION=1.0.0
PL_DESCR="Informix RDBMS"

echo '<P><A NAME="infOn"></A><H2>' $PL_DESCR '</h2>' 
if [ $SUMMARY -eq 0 ] ; then
 echo 'Plug-in version:' $PL_VERSION
fi

## Plug-in code
INFO_USER=informix

## Report
echo '<PRE>'
echo '<b>Users</b>'
grep -i $INFO_USER /etc/passwd

echo '<br>'
echo '<b>Active processes</b>'
$PS | grep $INFO_USER | grep -v ISA | grep -v grep

echo '<br>'
echo '<b>Statistics</b>'
su - $INFO_USER -c "onstat"

echo '<br>'
echo '<b>Configuration</b>'
## onstat -a reports too much infos
su - $INFO_USER -c "onstat -c" | grep -v "^#"
echo '</PRE>'

