# ux2p-XXX-MongoDB
# by mail@meo.bogliolo.name (c)
#
# HTML MongoDB Plugin
# Reports MongoDB configuration details
#
# Usage:
# called by ux2html.sh 
#
# Notes:
#  Uses SUMMARY, SYSTYPE, PS variables

# History:
#  14 Feb 13 1.0.0       meo     First release
#   1 Aug 15 1.0.1       meo     Much more info, Mac Brew file structure (b) checked with 3.2, Admin for user list


PL_VERSION=1.0.1b
PL_DESCR="MongoDB"

echo '<P><A NAME="MongoDB"></A><H2>' $PL_DESCR '</h2>' 
 echo 'Plug-in version:' $PL_VERSION

## Plug-in code
MDB_PARAM="--quiet"
#MDB_PARAM="--quiet -u root -p XXX --authenticationDatabase admin --port 27017 --host=HOSTNAME"
MDB_CONF_DIR=/data/mongodb/conf

if [ "x$PS" = "x" ]; 
  then PS='ps -efaww'
fi

## Report
echo '<PRE>'
echo '<b>Version</b>'
mongo $MDB_PARAM --eval 'db.serverStatus().version' 
mongo $MDB_PARAM --version  2> /dev/null

echo '<br>'
echo '<b>Active processes</b>'
$PS | grep mongo | grep -v grep

echo '<br>'
echo '<b>Software packages</b>'
eval $PKG | grep -i mongo 2> /dev/null

echo '<br>'
echo '<b>Current usage</b><br>'
$PS | grep -v grep | grep "mongod" > /dev/null
RES=$?
if [ $RES -eq 0 ]
then
    # mongo < mongo2html.js 2> /dev/null
    # echo ' <li> <a href="' mongo.htm '">' MongoDB '</a>'
    mongostat -n 1 --discover $MDB_PARAM
    echo
    mongostat -n 5 $MDB_PARAM

    echo '<br><b>Database List</b>'
    # mongo $MDB_PARAM --eval 'printjson(db._adminCommand("listDatabases").databases)' 
    mongo $MDB_PARAM << EOF
rs.slaveOk()
show dbs
EOF
    echo '<br><b>Current Activities</b>'
    mongo $MDB_PARAM --eval "printjson(db.currentOp())"
    echo '<br><b>Users</b>'
    mongo $MDB_PARAM --eval "db.system.users.find().pretty()" admin
    echo '<br><b>Detailed Database Status</b>'
    mongo $MDB_PARAM --eval "printjson(db.serverStatus())"
    mongo $MDB_PARAM --eval "printjson(db.hostInfo())"
    echo '<br><b>Database Statistics</b>'
    mongo $MDB_PARAM --eval 'db._adminCommand("listDatabases").databases.forEach(function (d) { mdb = db.getSiblingDB(d.name); printjson(mdb.stats()); })' 

    echo '<br><b>Replication</b>'
    mongo $MDB_PARAM --eval "printjson(rs.status()); rs.conf()"

else
	echo "No MongoDB service running"
fi
	
echo '<br>'
echo '<b>Configuration Files</b>'	
ls -l /etc/mongo*.conf /usr/local/etc/mongo*.conf $MDB_CONF_DIR/mongo*.conf 2>/dev/null
echo '<br>'

echo '<br><b>Configuration Parameters</b>'
for i in `ls /etc/mongo*.conf /usr/local/etc/mongo*.conf $MDB_CONF_DIR/mongo*.conf 2>/dev/null`
do
    echo '<b>' $i '</b>'
    grep -h -v ^# $i | grep -v ^$ 2>/dev/null
    echo
done
echo '</pre>'
echo '<p>'

