# ux2p-XXX-Sap
# by mail@meo.bogliolo.name (c)
#
# HTML SAP Plugin
# Reports SAP configuration details
#
# Usage:
# called by ux2html.sh 
#
# Notes:
#  Uses SUMMARY

# History:
#  1 Apr 06 1.0.0       meo     First release
#  1 Apr 10 1.0.1       meo     Small revision

PL_VERSION=1.0.1
PL_DESCR="SAP ERP"

echo '<P><A NAME="sap"></A><H2>' $PL_DESCR '</h2>' 
if [ $SUMMARY -eq 0 ] ; then
 echo 'Plug-in version:' $PL_VERSION
fi

## Plug-in code

## Report
  if [ -d /usr/sap ] ; then
	echo '<P><H3>SID</H3><PRE>'
	for SAPID in `cd /usr/sap; ls -d [A-Z]??`
	do
		echo $SAPID
	done
  	echo '</PRE>'

	if [ $SUMMARY -eq 0 ] ; then
	  echo '<P><H3>SAP Details</H3>'
	  for SAPID in `cd /usr/sap; ls -d [A-Z]??`
	  do
		SAPid=`echo $SAPID | tr "[:upper:]" "[:lower:]"`

		echo '<P><B>System Name</B>:' $SAPID 

		echo '<br><B> Central Instance</B>: '
		ls -d /usr/sap/$SAPID/DVEBMGS?? 2> /dev/null| cut -b 21-24

		echo '<br><B> Dialog Instances</B>:'
		ls -d /usr/sap/$SAPID/D?? 2> /dev/null | cut -b 15-18

		echo '<br><B>Administrator User </B>:'
		TEMP=adm ; TEMP=$SAPid$TEMP
		grep $TEMP /etc/passwd | awk -F ':' '{ print  $1, $5, $6 }'

		echo '<br><B>Oracle User</B>:'
		TEMP=ora ; TEMP=$TEMP$SAPid
		grep $TEMP /etc/passwd | awk -F ':' '{ print  $1, $5, $6 }'

		echo '<br><B> Disk usage</B>:<TABLE>'
		echo '<TR><TD><B>Directory</B><TD><B>Space (KB)</B>'
		du -sk /usr/sap/$SAPID 2>/dev/null | awk ' { print "<tr><td>", $2, "<td align=right>", $1 }'
		du -sk /oracle/$SAPID 2>/dev/null | awk ' { print "<tr><td>", $2, "<td align=right>", $1 }' 
		echo '</TABLE>'

		echo '<br><B> SAP Processes</B>:'
		echo '<BR><TABLE>'
		ps -efa | head -1 | table_row
		ps -efa | grep sapstart | grep $SAPID | grep -v grep | table_row
		ps -efa | grep tns | grep $SAPID | grep -v grep | table_row
		ps -efa | grep pmon | grep $SAPID | grep -v grep |table_row
		echo '</TABLE>'
	  done
# More info: niping -v niping -t showipc .../data/tbxstat /sapmnt/PTT/profile/PPT-**-**
        fi

  else
    echo '<p>SAP configuration not found'
  fi
