# ux2p-XXX-HAProxy
# by mail@meo.bogliolo.name (c)
#
# HTML HA Proxy Plugin
# Reports HA Proxy configuration details
#
# Usage:
# called by ux2html.sh 
#
# Notes:

# History:
#  1 Apr 14 1.0.0       meo     First release

PL_VERSION=1.0.1
PL_DESCR="HA Proxy"

echo '<P><A NAME="haproxy"></A><H2>' $PL_DESCR '</h2>' 
 echo 'Plug-in version:' $PL_VERSION

## Plug-in code
HA_USR=haproxy
HA_LINES=50

## Report
echo '<PRE>'

echo '<b>Users</b>'
grep -i $HA_USR /etc/passwd

echo '<br>'
echo '<b>Active processes</b>'
$PS | grep $HA_USR | grep -v grep

echo '</PRE>'

echo '<h2>HA Proxy Configuration Files</h2>'

for i in `ls /etc/haproxy/*.cfg`
do
  echo "<br><b>" $i "</b><p>"
  ls -l $i
  echo "<pre>"
  grep ^[a-z,A-Z] $i | head -$HA_LINES
  echo "..."
  grep ^[a-z,A-Z] $i | tail -$HA_LINES
  echo "</pre>"
done

