# ux2p-XXX-NginxProxy
# by mail@meo.bogliolo.name (c)
#
# HTML nginx Proxy Plugin
# Reports nginx Proxy configuration details
#
# Usage:
# called by ux2html.sh 
#
# Notes:

# History:
#  1 Apr 14 1.0.0       meo     First release

PL_VERSION=1.0.0
PL_DESCR="Nginx Proxy"

echo '<P><A NAME="nginx"></A><H2>' $PL_DESCR '</h2>' 
 echo 'Plug-in version:' $PL_VERSION

## Plug-in code
NX_USR=nginx
NX_LINES=50
NX_ERR=/var/log/nginx/error.log
NX_ACC=/var/log/nginx/access.log

## Report
echo '<PRE>'

echo '<b>Users</b>'
grep -i $NX_USR /etc/passwd

echo '<br>'
echo '<b>Active processes</b>'
$PS | grep $NX_USR | grep -v grep
echo '</PRE>'

echo '<h2>Nginx Configuration Files</h2>'

for i in `ls /etc/nginx/*.cfg /etc/nginx/*.conf /etc/nginx/conf.d/*.conf`
do
  echo "<br><b>" $i "</b><p>"
  ls -l $i
  echo "<pre>"
  cat $i | head -$NX_LINES
  echo "</pre>"
done

echo "<br><b>" Access Log "</b><p>"
ls -l $NX_ACC
echo "<pre>..."
cat $NX_ACC | tail -$NX_LINES
echo "</pre>"
echo "<br><b>" Error Log "</b><p>"
ls -l $NX_ERR
echo "<pre>..."
cat $NX_ERR | tail -$NX_LINES
echo "</pre>"

