# ux2p-XXX-FARO
# by mail@meo.bogliolo.name (c)
#
# HTML FARO Plugin
# Reports FARO configuration details
#
# Usage:
# called by ux2html.sh 
#
# Notes:

# History:
#  14 Feb 15 1.0.0       meo     First release

PL_VERSION=1.0.0
PL_DESCR="FARO"

echo '<P><A NAME="faro"></A><H2>' $PL_DESCR '</h2>' 
 echo 'Plug-in version:' $PL_VERSION

## Plug-in code
FARO_FILE='/var/log/crea.log /var/log/httpd/* /var/log/haproxy.log /var/log/zabbix/*'
FARO_ACCESS='/var/log/ACCESSI-FARO/*.csv'
FARO_HTTP_AUTH='/var/log/httpd/faro*.ecosis.csi.it-access.log*'
FARO_LOGLEN=10
FARO_ACCLEN=100

## Report
echo '<h2>Configuration and program Files</h2><p><pre>'
echo '<b>/usr/local/crea</b>'
ls -l /usr/local/crea | grep -v total
echo
echo '<b>/etc/haproxy</b>'
ls -l /etc/haproxy | grep -v total

echo '</pre><h2>User Access</h2><p><pre>'
# for i in  `ls -tr /var/log/ACCESSI-FARO/*.csv`
for i in  `ls -tr $FARO_ACCESS `
do
 echo "<b>"
 ls -l $i
 echo "</b>"
 md5sum $i
 tail -$FARO_ACCLEN $i |  awk -F',' '{ print "User: " $2 "  Action: " $5 "  Date:" $4 }'
 echo '...'
done
echo '</pre>'

echo '</pre><h2>HTTP Autentication</h2><p><pre>'
for i in  `ls -tr $FARO_ACCESS `
do
 echo "<b>"
 ls -l $i
 echo "</b>"
 md5sum $i
 grep -v '\- \-' $i | awk '{ print "User: " $3 "  IP: " $1 "  Date:" $4 }'| tr "[" " " | sort -u |tail -$FARO_ACCLEN
done
echo '...</pre>'

echo '</pre><h2>Log Files</h2><p><pre>'
for i in  $FARO_FILE
do
 echo "<b>"
 ls -l $i
 echo "</b>"
 tail -$FARO_LOGLEN $i
 echo '...'
done
echo '</pre>'

