# ux2p-XXX-SolarisLDom
# by mail@meo.bogliolo.name (c)
#
# HTML Solaris LDom Plugin
# Reports Solaris LDom configuration details
#
# Usage:
# called by ux2html.sh 
#
# Notes:
#	There are different packages for LDom: SUNWldm (LDoms 1.x), ldomsmanager (LDoms 2.x), 

# History:
#  1 Apr 10 1.0.0       meo     First release


PL_VERSION=1.0.0
PL_DESCR="Solaris LDom"

echo '<P><A NAME="sldom"></A><H2>' $PL_DESCR '</h2>' 
 echo 'Plug-in version:' $PL_VERSION

## Plug-in code
### PATH=$PATH:/opt/SUNWldm/bin

## Report
ldm list > /dev/null 2>&1
RES=$?
if [ $RES -eq 0 ] ; then
	echo '<P><H3>Configured Domains</H3><PRE>'
	ldm list # list-domain
  	
	echo '<P><H3>LDom Configurations</H3>'
	ldm list-spconfig

	echo '<P><H3>LDom Services</H3>'
	ldm list-services primary

	echo '<P><H3>LDom Bindngs</H3>'
	ldm list-bindings primary
  	
	for DOMID in `ldm list | awk '{ print $0 }' `
	    do
		echo '<P><B>LDom Name</B>:' $DOMID
		echo '<pre>'
		ldm list-services $DOMID
		ldm list-bindings $DOMID
		echo '</pre>'
	done

	### echo '<P><H3>LDom Configuration Details</H3>'
	### ldm list-constraints
	### ldm list-devices

	echo '<P><H3>LDom Installed Packages</H3>'
	pkg info ldomsmanager 2> /dev/null
	pkg info SUNWldm 2> /dev/null
 
else
    echo '<p>LDom configuration not found'
fi
