# ux2p-XXX-SolarisZone
# by mail@meo.bogliolo.name (c)
#
# HTML Solaris Zone Plugin
# Reports Solaris Zones configuration details
#
# Usage:
# called by ux2html.sh 
#
# Notes:

# History:
#  1 Apr 10 1.0.0       meo     First release


PL_VERSION=1.0.0
PL_DESCR="Solaris Zones"

echo '<P><A NAME="szone"></A><H2>' $PL_DESCR '</h2>' 
 echo 'Plug-in version:' $PL_VERSION

## Plug-in code

## Report
zoneadm list > /dev/null 2>&1
RES=$?
if [ $RES -eq 0 ] ; then
	echo '<P><H3>Configured Zones</H3><PRE>'
	zoneadm list -cv
  	echo '</PRE>'
	
	echo '<P><H3>Zones Details</H3>'
	for ZONEID in `zoneadm list`
	    do
		echo '<P><B>Zone Name</B>:' $ZONEID
		echo '<pre>'
		zonecfg -z $ZONEID export
		echo '</pre>'
	done

	echo '<P><H3>Processes</H3><pre>'
	ps -efo zone,user,pid,ppid,c,stime,tty,time,comm | sort
    echo '</pre>'

	echo '<P><H3>File Systems</H3><pre>'
	df -Z
    echo '</pre>'

else
    echo '<p>Zone configuration not found'
fi



