# ux2p-XXX-barman
# by mail@meo.bogliolo.name (c)
#
# HTML barman Plugin
# Reports barman configuration details
#
# Usage:
# called by ux2html.sh 
#
# Notes:

# History:
#  1 Jun 12 1.0.0		meo		First version
#  2 Jun 12 1.0.1		meo		Space usage

PL_VERSION=1.0.1
PL_DESCR="barman"

echo '<P><a id="barman"></A><H2>' $PL_DESCR '</h2>' 
echo 'Plug-in version:' $PL_VERSION

## Plug-in code
BAR_USR=barman
BAR_CONF=/etc/barman.conf
	
## Report
echo '<PRE>'

echo '<b>BARMAN Version</b>'
barman -v 2>&1

echo 
echo '<b>User</b>'
grep -i $BAR_USR /etc/passwd

echo 
echo '<b>Server</b>'
barman list-server

echo 
echo "<b>Check</b>"
barman list-server | awk ' { print $1 } ' | xargs barman check

echo 
echo "<b>Status</b>"
barman list-server | awk ' { print $1 } ' | xargs barman status

echo 
echo "<b>Backups</b>"
for i in `barman list-server`
do
    barman list-backup $i
done

echo 
echo "<b>Configuration</b>"
grep -v "^$" $BAR_CONF | grep -v "^;"

echo 
echo "<b>Scheduling</b>"
su - $BAR_USR -c "crontab -l"

echo 
echo "<b>Server Details</b>"
barman list-server | awk ' { print $1 } ' | xargs barman show-server

echo 
echo "<b>Space Usage</b>"
BHOME=`grep barman_home $BAR_CONF | awk ' { print $3 } '`
du -sk $BHOME/* | sort -n

echo '</PRE>'
