# ux2p-XXX-Solaris11
# by mail@meo.bogliolo.name (c)
#
# HTML Solaris 11
# Reports Solaris 11 new features
#
# Usage:
# called by ux2html.sh 
#
# Notes:
#  ZFS and Containers/zones were already available in Solaris 10

# History:
#  1 Apr 12 1.0.0       meo     First release
#  1 Aug 12 1.0.1       meo     Few changes

PL_VERSION=1.0.1
PL_DESCR="Solaris 11"

echo '<P><A NAME="sol11"></A><H2>' $PL_DESCR '</h2>' 
 echo 'Plug-in version:' $PL_VERSION

## Plug-in code

## Report
echo '<P>Contents: <a href="#s11net">Network</a>, <a href="#smf">SMF</a>, <a href="#iscsi">iSCSI</a>,'
echo ' <a href="#szfs">ZFS</a>, <a href="#szones">Zones</a>, <a href="#procsum">Processors</a>', <a href="#solpack">Packages</a>'

echo '<P><a id="s11net"></a><H3>Network Configuration</H3><pre>'
dladm show-phys ; echo
dladm show-ether ; echo 
dladm show-link ; echo
ipadm show-if ; echo
echo '</pre>'

echo '<P><a id="smf"></a><H3>SMF: Services Configuration</H3><pre>'
svcs ; echo
echo '</pre>'

echo '<P><a id="iscsi"></a><H3>iSCSI Configuration</H3><pre>'
iscsiadm list initiator-node ; echo; echo
iscsiadm list discovery ; echo; echo
iscsiadm list target ; echo
iscsiadm list target -vS ; echo
echo '</pre>'

echo '<P><a id="szfs"></a><H3>ZFS Summary</H3><pre>'
zpool list ; echo
zfs list ; echo
echo '</pre>'

echo '<P><a id="szones"></a><H3>Zones Summary</H3><pre>'
zoneadm list -cv; echo
echo '</pre>'

echo '<P><a id="procsum"></a><H3>Processors</H3><pre>'
echo "Physical Processors: " `psrinfo -p`; echo
psrinfo -pv; echo
echo '</pre>'

echo '<P><a id="solpack"></a><H3>Packages</H3><pre>'
pkg publisher
echo
beadm list -a
echo
pkg update -nv --accept
echo
pkg list
echo '</pre>'


