# ux2p-XXX-Apache
# by mail@meo.bogliolo.name (c)
#
# HTML Apache Plugin
# Reports Apache configuration details
#
# Usage:
# called by ux2html.sh 
#
# Notes:

# History:
#  1 Apr 10 1.0.0       meo     First release
#  1 Apr 11 1.0.1       meo     Smarter on finding configuration files
#  3 Sep 22 1.0.2       meo     No more egrep (deprecated since 2007 and with a warning in grep 3.8)

PL_VERSION=1.0.2
PL_DESCR="Apache HTTP Server"

echo '<P><A NAME="apache"></A><H2>' $PL_DESCR '</h2>'
echo 'Plug-in version:' $PL_VERSION

## Plug-in code
for i in /etc/httpd /usr/common/www /usr/local/apache2 /var/www /srv/www /usr/local/*/apache*
do
    FILE1=`find $i -name httpd.conf 2>/dev/null`
    CONF_FILE=$CONF_FILE" "$FILE1
    FILE1=`find $i -name ssl.conf 2>/dev/null`
    CONF_FILE=$CONF_FILE" "$FILE1
done

## Report
echo '<H2>Configuration files</h2>' 
echo $CONF_FILE
echo '<pre>'
ls -l $CONF_FILE
echo '</pre>'

echo '<H2>Most Important Configuration directives</h2>' 
for i in $CONF_FILE
do
    echo '<b>' $i '</b><pre>'
    cat $i | grep -v '^#' | grep -v '^    #' | grep -E 'VirtualHost|DocumentRoot|Listen|ServerName|ServerRoot|ErrorLog|KeepAlive' | tr "<>" "  "
    echo '</pre><br>'
done

echo '<H2>Active Processes</h2>' 
echo '<pre>'
ps -efa | grep http | grep -v grep
echo '</pre>'

echo '<H2>HTDOCS (using common location)</h2>' 
echo '<pre>'
ls -ld /usr/local/apache2/htdocs /var/www /srv/www/htdocs /var/www/html/htdocs /srv/www/htdocs /usr/local/*/apache*/htdocs 2> /dev/null
echo '</pre>'

echo '<H2>Full Configuration</h2>' 
for i in $CONF_FILE
do
    echo '<b>' $i '</b><pre>'
    cat $i | grep -v '^#' | grep -v '^    #' | tr "<>" "  "
    echo '</pre><br>'
done