# ux2p-XXX-Tomcat
# by mail@meo.bogliolo.name (c)
#
# Tomcat Plugin
# Reports Tomcat configuration details
#
# Usage:
# called by ux2html.sh 
#
# Notes:

# History:
#  1 Apr 10 1.0.0       meo     First release
#  3 Sep 22 1.0.1       meo     No more egrep (deprecated since 2007 and with a warning in grep 3.8)

PL_VERSION=1.0.1
PL_DESCR="Tomcat Application Server"

echo '<P><A NAME="tomcat"></A><H2>' $PL_DESCR '</h2>' 
if [ $SUMMARY -eq 0 ] ; then
 echo 'Plug-in version:' $PL_VERSION
fi

## Plug-in code
CONF_DIR=/opt

## Report
echo '<H2>Configuration files</h2>' 
echo "Searching from..." $CONF_DIR
echo '<pre>'
find $CONF_DIR -name server.xml -exec ls -l {} \;
echo '</pre>'

echo '<H2>Most Important Configuration directives</h2>' 
echo '<pre>'
find $CONF_DIR -name server.xml -print -exec grep 'Server port|Connector port|Host name' {} \; -exec echo \; | tr "<>" "  "
echo '</pre>'

echo '<H2>Database Connections</h2>' 
echo '<pre>'
find $CONF_DIR -name database.conf -print -exec grep jdbc {} \; -exec echo \;
echo '</pre>'

echo '<H2>Active Processes</h2>' 
echo '<pre>'
ps -efa | grep catalina | grep -v grep
echo '</pre>'
