# ux2p-XXX-CMDBuild
# by mail@meo.bogliolo.name (c)
#
# CMDBuild Plugin
# Reports CMDBuild configuration details
#
# Usage:
# called by ux2html.sh 
#
# Notes:

# History:
#  31 Nov 10 1.0.0       meo     First release

PL_VERSION=1.0.0
PL_DESCR="CMDBuild Application"

echo '<P><A NAME="cmdbuild"></A><H2>' $PL_DESCR '</h2>' 
echo 'Plug-in version:' $PL_VERSION

## Plug-in code
START_DIR=/usr/local/www
CONF_DIR=`find $START_DIR -name webapps`
DEPS=""
for i in $CONF_DIR
do
    if [ -d $i/cmdbuild ] ; then
	DEPS=$DEPS" "$i/cmdbuild
    fi
done
START_DIR=/opt/tomcat
CONF_DIR=`find $START_DIR -name webapps`
for i in $CONF_DIR
do
    if [ -d $i/cmdbuild ] ; then
	DEPS=$DEPS" "$i/cmdbuild
    fi
done

## Report
echo '<H2>Deployment</h2>' 
echo "Searching from..." $START_DIR
echo "<br>Application deployment on..." $CONF_DIR
echo "<br>CMDBuild deployment on...<b>" $DEPS "</b>"

echo '<H2>Version</h2>' 
for i in $DEPS
do
    echo '<li>' $i
    echo '<pre>'
    grep '"release":' $i/translations/it.json
    echo '</pre>'
done
echo '</ul>'

echo '<H2>Configuration</h2>' 
echo 'Most important configuration directives:<ul>'
for i in $DEPS
do
    echo '<li>' $i/WEB-INF/conf
    echo '<pre>'
    grep -E 'db.url|db.username|auth.methods|ldap.server|ldap.basedn|language' $i/WEB-INF/conf/*.conf | grep -v ":#"
    echo '</pre>'
done
echo '</ul>'

echo '<H2>Patches</h2>' 
echo '<ul>'
for i in $DEPS
do
    echo '<li>' $i/WEB-INF/patches
    echo '<pre>'
    ls -ltr $i/WEB-INF/patches/*
    echo '</pre>'
done
echo '</ul>'
