# ux2p-XXX-OAS
# by mail@meo.bogliolo.name (c)
#
# HTML Oracle Plugin
# Reports Oracle configuration details
#
# Usage:
# called by ux2html.sh 
#
# Notes:
#  Uses SUMMARY, OAS_USERS

# History:
#  1 Apr 06 1.0.0       meo     First release
#  1 May 06 1.0.1       meo     Minor graphical changes
# 31 Jun 10 1.0.2       meo     EBS R12 ; (b) owners' loop

PL_VERSION=1.0.2b
PL_DESCR="Oracle Application Server"

echo '<P><A NAME="oas"></A><H2>' $PL_DESCR '</h2>' 
 echo 'Plug-in version:' $PL_VERSION

## Plug-in code
#OAS_USERS="orias oracle"

OAS_USERS=""
PSCMD='ps -e -o user=VeryLongUserNames -o args'
for INST in `$PSCMD | grep "opmn" | grep -v grep | grep -v root | \
    awk ' { printf("%s\n", $1) }' | sort -u `
do
 OAS_USERS=`echo $OAS_USERS $INST`
done


## Report
if [ "X$OAS_USERS" = "X" ]
then
    echo '<p>Oracle Application Server configuration not found<p>'
else
    echo '<p><b>Oracle Application Server Farm Status</b> <p>'
    for i in $OAS_USERS
    do
        echo '<b>OAS User:</b>' $i '<pre>'
        su - $i <<EOF
echo "</pre><p><pre>"
eval "echo '<b>Home:</b>' \$ORACLE_HOME"
which opmnctl > /dev/null 2> /dev/null && opmnctl @farm status -l
which \$ADMIN_SCRIPTS_HOME/adopmnctl.sh > /dev/null 2> /dev/null && \$ADMIN_SCRIPTS_HOME/adopmnctl.sh status -l
echo '</pre>'
EOF
	echo '<! >'
    done
    echo '<p>'
fi

