# ux2p-XXX-ZFS
# by mail@meo.bogliolo.name (c)
#
# Reports ZFS configuration details and status
#
# Notes:

# History:
#   1 Jan 10 1.0.0       meo     First release
#  31 Feb 10 1.0.1       meo     Better formatting

PL_VERSION=1.0.1
PL_DESCR="ZFS - Z File System"

echo '<P><A NAME="zfs"></A><H2>' $PL_DESCR '</h2>' 
echo 'Plug-in version:' $PL_VERSION

## Plug-in code
LOGCOMM=100

## Report
echo '<P>Contents: <a href="#zfsVER">Version</a>, <a href="#zfsPOOL">Pools</a>, <a href="#zfsFS">File Systems</a>, <a href="#zfsORI">Origins</a>'
echo '<br>Details: <a href="#zfsPKG">Packages</a>, <a href="#zfsKER">Kernel Parameters</a>, <a href="#zfsSTAT">Statistics</a>, <a href="#zfsDB">Debugger Info</a>, <a href="#zfsCOMM">Last Commands</a>'

echo '<a name="zfsVER"></a><PRE><b>ZFS Version</b>'
zpool upgrade -v
zpool upgrade

echo '</pre><a name="zfsPOOL"></a><pre><b>Pools</b>'
zpool list
echo;echo
zpool status -v
echo '</PRE>'

echo '<a name="zfsFS"></a><b>File Systems</b>'
echo '<table><tr><td><b>Name</b><td><b>Used</b><td><b>Avail</b><td><b>Refer</b><td><b>Mount Point</b>'
zfs list | grep -v MOUNTPOINT |table_row
echo '</table>'

echo '<a name="zfsORI"></a><br><b>Origins</b><pre>'
zfs get origin 

# zfs get all					# Too much information...

echo '</pre><a name="zfsPKG"></a><br><b>ZFS Software Packages</b><pre>'
eval $PKG | grep -i zfs

echo '</pre><a name="zfsKER"></a><br><b>Kernel Parameters</b><pre>'
eval $KERNEL | grep -i zfs

echo '</pre><a name="zfsSTAT"></a><br><b>Statistics</b><pre>'
zpool iostat 5 5

echo '</pre><a name="zfsDB"></a><br><b>Debugger Info</b><pre>'
zdb

echo '</pre><a name="zfsCOMM"></a><br><b>Last Commands</b><pre>'
zpool history | tail -$LOGCOMM
echo '</PRE>'

