# ux2p-XXX-pacemaker
# by mail@meo.bogliolo.name (c)
#
# Reports Pacemaker configuration details and status
#
# Notes:

# History:
#   1 Jan 10 1.0.0       meo     First release
#  15 Aug 16 1.0.1       meo     Better formatting, updated to the last releases

PL_VERSION=1.0.1
PL_DESCR="Pacemaker - Open Source Cluster Resource Manager"

echo '<P><A NAME="pacem"></A><H2>' $PL_DESCR '</h2>' 
echo 'Plug-in version:' $PL_VERSION

## Plug-in code
LOGCOMM=100

## SHELL WAR: pcs status ; pcs config ; crm configure show

## Report
echo '<P>Contents: <a href="#pacemVER">Version</a>, <a href="#pacemSTATUS">Status</a>, <a href="#pacemPKG">Packages</a>'
echo '<br>Details: <a href="#pacemCONF">Configuration</a>, <a href="#pacemDSTATUS">Detailed Status</a>'

echo '<p><a name="pacemVER"></a><b>Pacemaker Version</b><pre>'
crm_mon --version

echo '</pre><a name="pacemSTATUS"></a><br><b>Status</b><pre>'
crm_mon -1
echo
pcs status corosync
echo
corosync-cfgtool -s
echo '</pre>'

echo '</pre><a name="pacemPKG"></a><br><b> Packages </b><pre>'
rpm -qa | grep -i pacemaker
rpm -qa | grep -i corosync
rpm -qa | grep -i pcs
echo '</pre>'

echo '</pre><a name="pacemCONF"></a><br><b>Configuration Files</b><p><pre>'
ls -l /etc/corosync/corosync.conf
ls -l /var/lib/pacemaker/cib/cib.xml
echo '</pre><p><b>corosync.conf</b><xmp>'
cat /etc/corosync/corosync.conf
echo '</xmp><p><b>cib.xml</b><xmp>'
cat /var/lib/pacemaker/cib/cib.xml
echo '</xmp>'

echo '</pre><a name="pacemDSTATUS"></a><br><b>Detailed Status</b><xmp>'
crm_mon -1 -o -t
echo
echo PCS CONFIG
pcs config
echo
echo COROSYNC-CMAPCTL
corosync-cmapctl
echo
echo PCS CLUSTER CIB
pcs cluster cib
echo '</xmp>'
