# ux2p-XXX-Symmetrix
# by mail@meo.bogliolo.name (c)
#
# HTML Virtual Plugin
# Reports EMC2 Symmetrix Configuration
#
# Usage:
# called by ux2html.sh 
#
# Notes:
#		Requires SYMCLI

# History:
#  1 Sep 10 1.0.0       meo     First release
# 31 Sep 10 1.0.1       meo     Bug fixing, better formatting

PL_VERSION=1.0.1
PL_DESCR="Symmetrix"

echo '<P><A NAME="symmetrix"></A><H2>' $PL_DESCR '</h2>' 
 echo 'Plug-in version:' $PL_VERSION

### Plug-in code
which symcli > /dev/null
RET=$?
if [ $RET -eq 0 ]
then
symcfg discover > /dev/null 2>&1

## Report
echo '<P>Contents: <a href="#symENC">Enclusures</a>, <a href="#symDEV">Devices</a>, <a href="#symFRE">Free Space</a>, <a href="#symDSK">Disks</a>, <a href="#symUSG">Current Usage</a>, <a href="#symHBA">HBA</a>, <a href="#symVER">SYMCLI</a>'
echo '<br>Details: <a href="#symMEM">Memory</a>, <a href="#symTDE">Thin Devices</a>, <a href="#symPOL">Pools</a>, <a href="#symSTA">Status</a>, <a href="#symCON">Connections</a>'

echo '<p><PRE><a name="symENC"></a><b>Symmetrix Enclosures</b>'
symcfg list
echo '<a name="symDEV"></a><b>Devices</b>'
symdev list
echo '<a name="symFRE"></a><b>Free Space</b>'
symconfigure list -free
echo '<a name="symDSK"></a><b>Disk Groups and Disks</b>'
symdisk list -by_diskgroup

echo ; echo '<a name="symDET"></a><b>Symmetrix Enclosures details</b>'
symcfg list -v
echo '<a name="symMEM"></a><b>Memory</b>'
symcfg list -memory
# echo '<a name="symAPP"></a><b>Applications</b>'
# symcfg list -application
echo '<a name="symTDE"></a><b>Thin Devices</b>'
symcfg list -tdev
echo '<a name="symPOL"></a><b>Pools</b>'
symcfg list -pool
echo '<a name="symSTA"></a><b>Status</b>'
symcfg list -status
echo ; echo '<a name="symCON"></a><b>Connections</b>'
symcfg list -connection

echo '<a name="symUSG"></a><b>Current Usage</b>'
symstat -i 5 -c 5
echo ; echo '<a name="symHBA"></a><b>Local HBA</b>'
symaccess list hba
echo '<a name="symVER"></a><b>SYMCLI Version</b>'
symcli
# symconfigure verify
# symhost show -config; symhost stat
echo '</PRE>'
else
	echo "<br>SYMCLI not found<br>"
fi
