# ux2p-XXX-OVM_Manager
# by mail@meo.bogliolo.name (c)
#
# Oracle VM Server Plugin
# Reports Oracle VM Manager configuration details
#
# Usage:
# called by ux2html.sh 
#
# Notes:
# Oracle VM Server version 3.2.1 or more

# History:
#  14 Feb 2013 1.0.0		meo		First version 

PL_VERSION=1.0.1
PL_DESCR="Oracle VM Manager"

echo '<P><a id="ovms"></A><H2>' $PL_DESCR '</h2>' 
echo 'Plug-in version:' $PL_VERSION

## Plug-in code
OVM_PASS=Manager1
	
## Report
echo '<h3>Oracle VM Manager Services</h3><pre>'
service ovmm status
echo
service ovmm_mysql status |  tr '[]' '  ' | tr -cd '[:print:]' | awk -F' ' '{ print $1 " " $2 " " $3 }'
echo '</pre>'

echo '<h3>Oracle VM Manager processes</h3><pre>'
ps -efa | grep oracle | grep -v grep
echo '</pre>'

echo '<h3>Oracle VM Manager configuration</h3><pre>'
cat /etc/sysconfig/ovmm
echo
/u01/app/oracle/ovm-manager-3/bin/ovm_admin --listconfig
echo '</pre>'

echo '<h3>Oracle VM Manager backups</h3><pre>'
source /etc/sysconfig/ovmm
du -sk $DBBACKUP/*
echo '</pre>'

echo '<h3>Oracle VM Users</h3><pre>'
echo $OVM_PASS | /u01/app/oracle/ovm-manager-3/bin/ovm_admin --listusers 2>/dev/null | grep -i user
echo '</pre>'
