# ux2p-XXX-OVM_Server
# by mail@meo.bogliolo.name (c)
#
# Oracle VM Server Plugin
# Reports Oracle VM Server configuration details
#
# Usage:
# called by ux2html.sh 
#
# Notes:
# Oracle VM Server version 3.2.1 or more

# History:
#  14 Feb 13 1.0.0		meo		First version 

PL_VERSION=1.0.0
PL_DESCR="Oracle VM Server"

echo '<P><a id="ovms"></A><H2>' $PL_DESCR '</h2>' 
echo 'Plug-in version:' $PL_VERSION

## Plug-in code
LOGLEN=40
	
## Report
echo '<h3>Oracle VM Server Version</h3><pre>'
rpm -qa | grep -i ovs-release | awk -F'-' '{print $3}'
echo
rpm -qa | grep -i ovs
rpm -qa | grep -i ovm
rpm -qa | grep -i xen

echo
echo '</pre><h3>Oracle VM Server Agent Status</h3><pre>'
service ovs-agent status
echo '</pre>'

echo
echo '</pre><h3>Oracle VM Server Services Status</h3><pre>'
echo DEVMON
service ovs-devmon status
echo
echo CONSOLED
service ovm-consoled status
echo
echo OVM WATCH
service ovmwatch status
echo
echo O2CB 
service o2cb status

echo '<h3>Running Domains</h3><pre>'
xm list
echo '</pre>'

echo '<h3>Repositories Tree</h3><pre>'
( cd /OVS/Repositories/; ls -R  | grep ":$" | sed -e 's/:$//' -e 's/[^-][^\/]*\//--/g' -e 's/^/   /' -e 's/-/|/' )
echo '</pre>'

echo '<h3>Repositories Content</h3><pre>'
find /OVS/Repositories -type f -exec ls -l {} \;
echo '</pre>'

echo '<p><h3>VM Configuration files</h3><pre>'
find /OVS/Repositories -name 'vm.cfg' -exec ls -l {} \; -exec echo \; -exec cat {} \; -exec echo \; -exec echo \;
# cat /var/ovs/mount/*/running_pool/*/vm.cfg
echo '</pre>'

echo '</pre><h3>Agent configuration</h3><pre>'
grep -v '^;' /etc/ovs-agent/agent.ini | grep -v '^$'
echo '</pre>'

echo '<h3>Logs</h3><pre>'
echo
echo OVS AGENT
tail -$LOGLEN /var/log/ovs-agent.log
echo
echo DEVMON
tail -$LOGLEN /var/log/devmon.log
echo
echo OVM WATCH
tail -$LOGLEN /var/log/ovmwatch.log
echo
echo OVM CONSOLE
tail -$LOGLEN /var/log/ovm-consoled.log
echo '</pre>'

echo '<p>See also: <a href="#gfs2">OCF2</a>, <a href="#virtual">Xen</a>, <a href="#ovmu">OVM CLI</a><p><p>'
