# ux2p-XXX-ODA
# by mail@meo.bogliolo.name (c)
#
# HTML ODA (Oracle Database Appliance) Plugin
# Reports ODA configuration details
#
# Usage:
# called by ux2html.sh 
#
# Notes:

# History:
#   1 Apr 13 1.0.0       meo     First release
#   1 Jan 14 1.0.1       meo     2.8 Bundle, ODA X4-2 revision
#  14 Feb 17 1.0.2       meo     12.1.2.10.0 Bundle revision. show fs, bundle inventory
#  17 Oct 17 1.0.3       meo     bug fixing
#   2 Aug 19 1.0.4       meo     fwupdate

PL_VERSION=1.0.4
PL_DESCR="ODA"

echo '<P><A NAME="ODA"></A><H2>' $PL_DESCR '</h2>' 
 echo 'Plug-in version:' $PL_VERSION

### Plug-in code
ODA_CMD=/opt/oracle/oak/bin/oakcli
ASR_CMD=/opt/SUNWswasr/bin/asr
ASR_CMD=/opt/asrmanager/bin/asr
ODA_LOG=/opt/oracle/oak/log/`hostname`/client/oakcli.log
ODA_MOD=`eval $ODA_CMD show env_hw | head -1 | awk ' { print $1 } '`
if [ ! -n "$ERRLEN" ]
then
  ERRLEN=200
fi

## Report
echo '<pre>'
echo '<b>Hardware</b>'
eval $ODA_CMD show env_hw
echo;echo '<b>Version</b>'
eval $ODA_CMD show version -detail
echo '<b>Power</b>'
eval $ODA_CMD show power
echo '<b>Processor</b>'
eval $ODA_CMD show processor
echo '<b>Memory</b>'
eval $ODA_CMD show memory
echo '<b>Disk</b>'
eval $ODA_CMD show disk -local
echo
eval $ODA_CMD show disk -shared
echo
eval $ODA_CMD show diskgroup
echo
echo '<b>FSs</b>'
eval $ODA_CMD show fs
echo
echo '<b>Network</b>'
eval $ODA_CMD show network
echo '<b>Database</b>'
eval $ODA_CMD show databases
echo
eval $ODA_CMD show dbstorage

if [ $ODA_MOD == "BM" ]
then
 echo
 echo '<b>Bare Metal Platform</b>'
 echo
 echo '<b>Core Licensing</b>'
 echo
 eval $ODA_CMD show core_config_key
else
 echo
 echo '<b>Virtualized Platform</b>'
 echo
 echo '<b>Repository</b>'
 eval $ODA_CMD show repo
 echo '<b>CPU Pool</b>'
 eval $ODA_CMD show cpupool -node 0
 echo
 eval $ODA_CMD show cpupool -node 1
 echo '<b>VM</b>'
 eval $ODA_CMD show vm
fi

echo
echo '<b>ASR Assets</b>'
eval $ASR_CMD list_asset
# Config file /var/opt/SUNWsasm/configuration/config.ini
echo

echo
echo '<b>Bundle Inventory</b>'
echo
eval $ODA_CMD inventory -q

echo
echo '<b>ACFS</b>'
acfsutil info fs
echo

echo
echo '<b>Firmware Update</b>'
echo
fwupdate list all
echo

echo
echo '<b>Log</b>'
echo
cat $ODA_LOG | tail -$ERRLEN

echo '</pre>'
