# ux2p-XXX-Asterisk
# by mail@meo.bogliolo.name (c)
#
# HTML Asterisk Plugin
# Reports Asterisk configuration details
#
# Usage:
# called by ux2html.sh 
#
# Notes:

# History:
# 21 Jun 09 1.0.1       dg      Version information
#  1 Aug 08 1.0.0       meo     First release

PL_VERSION=1.0.2
PL_DESCR="Asterisk"

echo '<P><A NAME="asterisk"></A><H2>' $PL_DESCR '</h2>' 
 echo 'Plug-in version:' $PL_VERSION

## Plug-in code
AST_CONF=/etc/asterisk

## Report
echo '<PRE>'
echo '<b>Version</b>'
asterisk -rx "core show version" 2> /dev/null
RES=$?
if [ $RES -eq 0 ]
then
 echo '<br>'
 echo '<b>Active processes</b>'
 ps -efa | grep asterisk | grep -v grep

 echo '<br>'
 echo '<b>Configuration</b>'
 for i in `ls $AST_CONF/*.conf | grep -v indications.conf | grep -v say.conf`
 do
    echo "<p><br><b>" $i "</b><br>"
    grep -v "[:space:]*;" $i | grep -v "^$" | grep -v "^#"
 done
else
 echo '<br>'
 echo '<b>Asterisk configuration NOT found</b>'
fi

echo '</PRE>'
