# ux2p-XXX-AsteriskLive
# by mail@meo.bogliolo.name (c)
#
# HTML Asterisk Activities Plugin
# Reports Asterisk configuration details
#
# Usage:
# called by ux2html.sh 
#
# Notes:

# History:
#  1 Jan 17 1.0.0       meo     First release

PL_VERSION=1.0.0
PL_DESCR="AsteriskLive"

echo '<P><A NAME="asteriskLive"></A><H2>' $PL_DESCR '</h2>' 
 echo 'Plug-in version:' $PL_VERSION

## Plug-in code
AST_CONF=/etc/asterisk
AST_LOG=/var/log/asterisk/messages
AST_LINES=100

## Report
echo '<PRE>'
echo '<b>Version</b>'
asterisk -rx "core show version" 2> /dev/null
RES=$?
if [ $RES -eq 0 ]
then
 echo '<br><b>Core Channels</b>'
 asterisk -rx "core show channels" 2> /dev/null
 echo '<br><b>SIP Channels</b>'
 asterisk -rx "sip show channels" 2> /dev/null
 echo '<br><b>Registry</b>'
 asterisk -rx "sip show registry" 2> /dev/null
 echo '<br><b>Peers</b>'
 asterisk -rx "sip show peers" 2> /dev/null
 echo '<br><b>LOG</b>'
 cat $AST_LOG | tail -$AST_LINES
else
 echo '<br>'
 echo '<b>Asterisk command NOT found</b>'
fi

echo '</PRE>'
