# ux2p-XXX-XCally
# by mail@meo.bogliolo.name (c)
#
# HTML XCally Plugin
# Reports XCally configuration details
#
# Usage:
# called by ux2html.sh 
#
# Notes:

# History:
#  1 Jan 17 1.0.0       meo     First release

PL_VERSION=1.0.0
PL_DESCR="XCally"

echo '<P><A NAME="XCally"></A><H2>' $PL_DESCR '</h2>' 
 echo 'Plug-in version:' $PL_VERSION

## Plug-in code
XC_USR=motion
XC_USR2=xcally
XC_LINES=50
XC_ERR=/var/log/xcally/motion-err.log
XC_ACC=/var/log/xcally/motion-out.log

## Report
echo '<PRE>'
echo '<b>PM2 Info</b>'
pm2 list
pm2 show motion

echo '<br>'
echo '<b>Active processes</b>'
$PS | grep $XC_USR | grep -v grep
$PS | grep $XC_USR2 | grep -v grep

echo '<br>'
echo '<b>XCally version (Git Info)</b>'
( cd /var/opt/motion; git log | head -20 )
echo '</PRE>'

echo '<h2>XCally LOGS</h2>'

echo "<br><b>" Access Log "</b><p>"
ls -l $XC_ACC
echo "<pre>..."
cat $XC_ACC | tail -$XC_LINES
echo "</pre>"
echo "<br><b>" Error Log "</b><p>"
ls -l $XC_ERR
echo "<pre>..."
cat $XC_ERR | tail -$XC_LINES
echo "</pre>"
