# ux2p-XXX-Security
# by mail@meo.bogliolo.name (c)
#
# Security
# Reports Security configuration details and status
#
# Notes:
#  First release only for Linux OS

# History:
#  1 Nov 10 1.0.0       meo     First release
# 16 Dec 15 1.0.1       meo     Sudoers

PL_VERSION=1.0.1
PL_DESCR="Security info"
SYSTYPE=`uname -s`

echo '<P><A NAME="sec"></A><H2>' $PL_DESCR '</h2>' 
if [ $SUMMARY -eq 0 ] ; then
 echo 'Plug-in version:' $PL_VERSION
fi

## Plug-in code

## Report

if [ $SYSTYPE = Linux ]
then

echo '<p><b>IP Tables (Firewall)</b>'
echo '<PRE>'
service iptables status
echo '</PRE>'

echo '<b>SElinux</b><p>'
echo ; echo '<b>Configuration</b>'
echo '<PRE>'
grep -v ^# /etc/selinux/config | grep -v ^$
echo '</PRE>'
echo ; echo '<b>Packages</b>'
echo '<PRE>'
rpm -qa | grep sec | grep -v xmlsec
echo '</PRE>'

echo '<b>Critical System Files</b><p>'
echo '<PRE>'
ls -ld /etc/passwd /etc/shadow /var/log /var/log/messages /etc/crontab /etc/syslog.conf /etc/logrotate.conf /var/log/wtmp /var/log/lastlog /etc/ftpusers /etc/pam.d /etc/hosts.allow /etc/hosts.deny /etc/lilo.conf /etc/securetty /etc/shutdown.allow /etc/security /etc/rc.d/init.d /etc/init.d /etc/sysconfig /etc/inetd.conf /etc/cron.allow /etc/cron.deny /etc/ssh /etc/sysctl.conf 2>/dev/null
md5 /etc/passwd /etc/shadow /var/log /var/log/messages /etc/crontab /etc/syslog.conf /etc/logrotate.conf /var/log/wtmp /var/log/lastlog /etc/ftpusers /etc/pam.d /etc/hosts.allow /etc/hosts.deny /etc/lilo.conf /etc/securetty /etc/shutdown.allow /etc/security /etc/rc.d/init.d /etc/init.d /etc/sysconfig /etc/inetd.conf /etc/cron.allow /etc/cron.deny /etc/ssh /etc/sysctl.conf 2>/dev/null
echo '</PRE>'

echo '<b>Remote Host Allow/Deny</b><p>'
echo '<PRE>'
echo '<b>Host deny</b>'
grep -v ^# /etc/hosts.deny | grep -v ^$
echo '<b>Host allow</b>'
grep -v ^# /etc/hosts.allow | grep -v ^$
echo '</PRE>'

echo '<b>Sudoers</b><p>'
echo '<PRE>'
grep -v ^# /etc/sudoers | grep -v ^$
echo '</PRE>'

echo '<b>Password expiration/changes</b><p>'
echo '<PRE>'
chage -l root
echo
cat /etc/shadow | grep -v ":\*:" | grep -v ":\!\!:" | awk -F: ' { print "User: " $1 " \tExpiration (0 never): " $4 } '
echo '</PRE>'

echo '<b>SUID files</b><p>'
echo '<PRE>'
find / -fstype nfs -prune -o -type f -perm +6000 -ls
echo '</PRE>'

echo '<b>Auditig reports</b><p>'
echo '<XMP>'
aureport --summary
aureport -au --failed --summary -i
aureport -u --failed --summary -i
aureport -t
echo '</XMP>'

echo '<b>Shellshock</b><p>'
echo '<PRE>'
echo Basic test...
env x='() { :;}; echo vulnerable' bash -c "echo Test completed" 

echo Advanced test...
env 'x=() { :;}; echo vulnerable' 'BASH_FUNC_x()=() { :;}; echo vulnerable' bash -c "echo Test completed"

echo 7169 test...
cd /tmp; rm -f /tmp/echo; env 'x=() { (a)=>\' bash -c "echo date"; cat /tmp/echo
echo "If a date has been shown the bug 7169 is still present"
echo '</PRE>'

fi
